require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/tools/teams', type: :request do
  let(:valid_attributes) do
    { rca_id: rca.id, tool_reference: 1, tool_num: 1,
      person_id: person.id, profil_id: profil.id }
  end
  let(:invalid_attributes) do
    { rca_id: rca.id, tool_reference: 1, tool_num: 1,
      person_id: nil, profil_id: profil.id }
  end

  let(:rca) { FactoryBot.create(:rca, methodology: methodology) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  let(:person) { FactoryBot.create(:person) }
  let(:user) { FactoryBot.create(:user, person_id: person.id) }
  let(:profil) { FactoryBot.create(:profil) }

  context 'From logged user' do
    before :each do
      user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
      user.save!

      sign_in user
    end

    describe 'GET /index' do
      it 'renders a successful response' do
        Tools::Team.create! valid_attributes
        get tools_teams_url, params: {rca: rca.id}
        expect(response).to be_successful
      end
    end

    # describe 'GET /show' do
    #   it 'renders a successful response' do
    #     tools_team = Tools::Team.create! valid_attributes
    #     get tools_team_url(tools_team)
    #     expect(response).to be_successful
    #   end
    # end

    describe 'GET /new' do
      context 'without rca defined' do
        it 'renders a redirection response' do
          get new_tools_team_path, params: {}, xhr: true
          expect(response).to have_http_status(:redirect)
          expect(response).to redirect_to(rcas_path)
        end
      end

      context 'with rca and step_tool defined' do
        it 'renders a successful response' do
          get new_tools_team_path, params: { tools_team: valid_attributes }, xhr: true
          expect(response).to be_successful
        end
      end
    end

    describe 'GET /edit' do
      it 'render a successful response' do
        tools_team = Tools::Team.create! valid_attributes
        get edit_tools_team_url(tools_team), params: {}, xhr: true
        expect(response).to be_successful
      end
    end

    describe 'POST /create' do
      context 'with valid parameters' do
        it 'creates a new Tools::Team' do
          expect {
            post tools_teams_url, params: { tools_team: valid_attributes }, xhr: true
          }.to change(Tools::Team, :count).by(1)
        end

        it 'redirects to the created tools_team' do
          post tools_teams_url, params: { tools_team: valid_attributes }, xhr: true
          expect(response).to redirect_to(tools_teams_url(rca: rca))
        end
      end

      context 'with invalid parameters' do
        it 'does not create a new Tools::Team' do
          expect {
            post tools_teams_url, params: { tools_team: invalid_attributes }, xhr: true
          }.to change(Tools::Team, :count).by(0)
        end

        it 'renders a successful response (i.e. to display the new template)' do
          post tools_teams_url, params: { tools_team: invalid_attributes }, xhr: true
          expect(response).to be_successful
        end
      end
    end

    describe 'PATCH /update' do
      context 'with valid parameters' do
        let(:new_attributes) { {person_id: person2.id, profil_id: profil2.id} }
        let(:person2) { FactoryBot.create(:person) }
        let(:profil2) { FactoryBot.create(:profil) }

        it 'updates the requested tools_team' do
          tools_team = Tools::Team.create! valid_attributes
          patch tools_team_url(tools_team), params: { tools_team: new_attributes }, xhr: true
          tools_team.reload
          expect(tools_team.profil).to eq profil2
          expect(tools_team.person).to eq person2
        end

        it 'redirects to the tools_team' do
          tools_team = Tools::Team.create! valid_attributes
          patch tools_team_url(tools_team), params: { tools_team: new_attributes }, xhr: true
          tools_team.reload
          expect(response).to redirect_to(tools_teams_url(rca: rca))
        end
      end

      context 'with invalid parameters' do
        it 'renders a successful response (i.e. to display the edit template)' do
          tools_team = Tools::Team.create! valid_attributes
          patch tools_team_url(tools_team), params: { tools_team: invalid_attributes }, xhr: true
          expect(response).to be_successful
        end
      end
    end

    describe 'DELETE /destroy' do
      it 'destroys the requested tools_team' do
        tools_team = Tools::Team.create! valid_attributes
        expect {
          delete tools_team_url(tools_team)
        }.to change(Tools::Team, :count).by(-1)
      end

      it 'redirects to the tools_teams list' do
        tools_team = Tools::Team.create! valid_attributes
        delete tools_team_url(tools_team)
        expect(response).to redirect_to(tools_teams_url(rca: rca))
      end
    end
  end
end
